# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Functions

* [`update_trusted_facts::trusted_fact_names`](#update_trusted_factstrusted_fact_names): Returns an array of trusted facts lint:ignore:140chars

### Tasks

* [`confirm_primary_server`](#confirm_primary_server): A short description of this task
* [`set_csr_attributes`](#set_csr_attributes): Merges existing trusted fact

### Plans

* [`update_trusted_facts::update_trusted_facts`](#update_trusted_factsupdate_trusted_facts): PE plan to update trusted facts on a certificate via Puppet enterprise console, while preserving existing trusted facts.

## Functions

### <a name="update_trusted_factstrusted_fact_names"></a>`update_trusted_facts::trusted_fact_names`

Type: Puppet Language

Returns an array of trusted facts
lint:ignore:140chars

#### `update_trusted_facts::trusted_fact_names()`

Returns an array of trusted facts
lint:ignore:140chars

Returns: `Array`

## Tasks

### <a name="confirm_primary_server"></a>`confirm_primary_server`

A short description of this task

**Supports noop?** false

#### Parameters

##### `pe_primary_server`

Data type: `String`

Puppet Primary server hostname

##### `ignore_infra_status_error`

Data type: `Boolean`

Ignore puppet infra status stderr

### <a name="set_csr_attributes"></a>`set_csr_attributes`

Merges existing trusted fact

**Supports noop?** false

#### Parameters

##### `trusted_facts`

Data type: `Hash`

Trusted facts to add

##### `preserve_existing_facts`

Data type: `Boolean`

Preserve existing trusted facts

## Plans

### <a name="update_trusted_factsupdate_trusted_facts"></a>`update_trusted_facts::update_trusted_facts`

lint:ignore:140chars lint:ignore:strict_indent

This plans allows for the easy modification of trusted facts on already deployed nodes via the Puppet Enterprise console.
It will preserve the existing trusted facts by reading the existing certificate and merging any proposed changes over existing. This behaviour can be changed by setting the preserve_existing_facts parameter to false
We require the Puppet Primary to be specified when runing the plan due to limitations of running plans in orchestor.

To learn more about Puppet plans, see documentation:
- http://pup.pt/bolt-puppet-plans
- https://www.puppet.com/docs/pe/2021.7/plans_limitations.html

#### Parameters

The following parameters are available in the `update_trusted_facts::update_trusted_facts` plan:

* [`targets`](#targets)
* [`pe_primary_server`](#pe_primary_server)
* [`preserve_existing_facts`](#preserve_existing_facts)
* [`ignore_infra_status_error`](#ignore_infra_status_error)
* [`noop`](#noop)
* [`pp_role`](#pp_role)
* [`pp_uuid`](#pp_uuid)
* [`pp_environment`](#pp_environment)
* [`pp_apptier`](#pp_apptier)
* [`pp_department`](#pp_department)
* [`pp_datacenter`](#pp_datacenter)
* [`pp_instance_id`](#pp_instance_id)
* [`pp_image_name`](#pp_image_name)
* [`pp_preshared_key`](#pp_preshared_key)
* [`pp_cost_center`](#pp_cost_center)
* [`pp_product`](#pp_product)
* [`pp_project`](#pp_project)
* [`pp_application`](#pp_application)
* [`pp_service`](#pp_service)
* [`pp_employee`](#pp_employee)
* [`pp_created_by`](#pp_created_by)
* [`pp_software_version`](#pp_software_version)
* [`pp_cluster`](#pp_cluster)
* [`pp_provisioner`](#pp_provisioner)
* [`pp_region`](#pp_region)
* [`pp_zone`](#pp_zone)
* [`pp_network`](#pp_network)
* [`pp_securitypolicy`](#pp_securitypolicy)
* [`pp_cloudplatform`](#pp_cloudplatform)
* [`pp_hostname`](#pp_hostname)

##### <a name="targets"></a>`targets`

Data type: `TargetSpec`

The targets to run on (note this must match the certnames used by Puppet / shown in PE console).

##### <a name="pe_primary_server"></a>`pe_primary_server`

Data type: `Stdlib::Fqdn`

The Puppet Enterprise primary server in your PE installation you are running the plan from.

##### <a name="preserve_existing_facts"></a>`preserve_existing_facts`

Data type: `Boolean`

Whether to preserve existing facts from the nodes. If set to false all existing facts will be wiped and replaced with those set in the plan. Default: true

Default value: ``true``

##### <a name="ignore_infra_status_error"></a>`ignore_infra_status_error`

Data type: `Boolean`

Ignore errors from 'puppet infrastructure status' command. This is used to verify the primary server. Can be used to allow the plan the run when some PE components are unavaliable. Default: false

Default value: ``false``

##### <a name="noop"></a>`noop`

Data type: `Boolean`

Run the plan in noop. csr_attributes.yaml will still generated, however certificates will not be resigned. Default: false

Default value: ``false``

##### <a name="pp_role"></a>`pp_role`

Data type: `Optional[String]`

Set the pp_role trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_uuid"></a>`pp_uuid`

Data type: `Optional[String]`

Set the pp_uuid trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_environment"></a>`pp_environment`

Data type: `Optional[String]`

Set the pp_environment trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_apptier"></a>`pp_apptier`

Data type: `Optional[String]`

Set the pp_apptier trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_department"></a>`pp_department`

Data type: `Optional[String]`

Set the pp_department trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_datacenter"></a>`pp_datacenter`

Data type: `Optional[String]`

Set the pp_datacenter trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_instance_id"></a>`pp_instance_id`

Data type: `Optional[String]`

Set the pp_instance_id trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_image_name"></a>`pp_image_name`

Data type: `Optional[String]`

Set the pp_image_name trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_preshared_key"></a>`pp_preshared_key`

Data type: `Optional[String]`

Set the pp_preshared_key trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_cost_center"></a>`pp_cost_center`

Data type: `Optional[String]`

Set the pp_cost_center trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_product"></a>`pp_product`

Data type: `Optional[String]`

Set the pp_product trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_project"></a>`pp_project`

Data type: `Optional[String]`

Set the pp_project trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_application"></a>`pp_application`

Data type: `Optional[String]`

Set the pp_application trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_service"></a>`pp_service`

Data type: `Optional[String]`

Set the pp_service trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_employee"></a>`pp_employee`

Data type: `Optional[String]`

Set the pp_employee trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_created_by"></a>`pp_created_by`

Data type: `Optional[String]`

Set the pp_created_by trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_software_version"></a>`pp_software_version`

Data type: `Optional[String]`

Set the pp_software_version trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_cluster"></a>`pp_cluster`

Data type: `Optional[String]`

Set the pp_cluster trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_provisioner"></a>`pp_provisioner`

Data type: `Optional[String]`

Set the pp_provisioner trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_region"></a>`pp_region`

Data type: `Optional[String]`

Set the pp_region trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_zone"></a>`pp_zone`

Data type: `Optional[String]`

Set the pp_zone trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_network"></a>`pp_network`

Data type: `Optional[String]`

Set the pp_network trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_securitypolicy"></a>`pp_securitypolicy`

Data type: `Optional[String]`

Set the pp_securitypolicy trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_cloudplatform"></a>`pp_cloudplatform`

Data type: `Optional[String]`

Set the pp_cloudplatform trusted fact. Default: undef

Default value: ``undef``

##### <a name="pp_hostname"></a>`pp_hostname`

Data type: `Optional[String]`

Set the pp_hostname trusted fact. Default: undef

Default value: ``undef``

